Distribution:   CCux
Packager:	Christian Wasem <wasem@ccux-linux.de>

Name:		db
Version:	4.4.20
Release:	1
License:	GNU/GPL
Group:		Databases
Summary:	The Berkeley DB database library Version 4.
URL:		http://www.sleepycat.com/
Provides:	libdb-4.3.so
Provides:	%{name}
# Sources #
Source:		%{name}-%{version}.tar.bz2
Source1:	db.1.85.tar.bz2
# DB 4.x Patches #
Patch1:		patch.4.4.20.1
Patch2:		patch.4.4.20.2
Patch3:		%{name}-%{version}-doc-location.patch
Patch4:		%{name}-%{version}-noerror-build.patch
# DB 1.85 Patches #
Patch10:	patch.1.1
Patch11:	patch.1.2
Patch12:	patch.1.3
Patch13:	patch.1.4
Patch14:	db-1.85-errno.patch
# Buildrequirements #
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	ed
BuildPreReq:	perl tcl

%define		major		4.4
%define		_libdb_a	libdb-%major.a
%define		_libcxx_a	libdb_cxx-%major.a

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

%package	devel
Summary:	Development files for the Berkeley DB (version 4) library.
Group:		%{group}
Requires:	%{name} = %{version}-%{release}

%description	devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the header files,
libraries, and documentation for building programs which use the
Berkeley DB.

%package	doc
Summary: 	%{name} documents.
Group: 		%{group}            
Requires: 	%{name} = %{version}-%{release}

%description	doc
%{name} documents.

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%prep
%setup -q -n %{name}-%{version} -a 1
%patch1 -p0 -b .fix1~
%patch2 -p0 -b .fix2~
%patch3 -p1
%patch4 -p1
pushd db.1.85/PORT/linux
%patch10 -p0 -b .1
cd ../..
%patch11 -p0 -b .1
%patch12 -p0 -b .2
%patch13 -p0 -b .3
%patch14 -p1 -b .errno
popd

# Remove tags files which we don't need.
find . -name tags | xargs rm -f

%build
# Static link with old db-185 libraries.
make -C db.1.85/PORT/%{_os} OORG="$CFLAGS"
libtool --mode=compile --tag=CC %{__cc} $RPM_OPT_FLAGS -Idb.1.85/PORT/%{_os}/include -D_REENTRANT -c db_dump185/db_dump185.c -o dist/db_dump185.lo
libtool --mode=link --tag=CC   %{__cc} -o dist/db_dump185 dist/db_dump185.lo db.1.85/PORT/%{_os}/libdb.a
# XXX --enable-posixmutexes is useful for threads but useless for interprocess locking.
# XXX --enable-diagnostic should be disabled for production (but is useful).
# XXX --enable-debug_{r,w}op should be disabled for production.
pushd dist
# Make sure configure doesn't get rebuilt w/o the s_config edits...
sh s_config

%configure \
	--enable-compat185 --enable-dump185 \
	--enable-shared --enable-static --enable-rpc \
	--enable-tcl --with-tcl=%_libdir \
	--enable-cxx --enable-test \
	# --enable-diagnostic \
	# --enable-debug --enable-debug_rop --enable-debug_wop \
	# --enable-posixmutexes
make libdb=%_libdb_a libcxx=%_libcxx_a
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%_includedir
mkdir -p $RPM_BUILD_ROOT%_libdir
%makeinstall -C dist libdb=%_libdb_a libcxx=%_libcxx_a
chmod +x $RPM_BUILD_ROOT%_libdir/*.so*

# On Linux systems, move the shared libraries to lib directory, but leave the
# versioned .so symlink to in the usual place to link against.
if [ "%_libdir" != "/%_lib" ]; then
	mkdir -p $RPM_BUILD_ROOT/%_lib
	mv $RPM_BUILD_ROOT%_libdir/libdb[-.]*so* $RPM_BUILD_ROOT/%_lib/
	touch $RPM_BUILD_ROOT/rootfile
	root=..
	while [ ! -e $RPM_BUILD_ROOT%_libdir/${root}/rootfile ] ; do
		root=${root}/..
	done
	ln -sf ${root}/%_lib/libdb-%major.so $RPM_BUILD_ROOT/%_libdir/libdb-%major.so
	for i in cxx tcl; do
		ln -sf libdb_$i-%major.so $RPM_BUILD_ROOT%_libdir/libdb_$i.so
	done
fi

rm -f $RPM_BUILD_ROOT/rootfile

# Move the header files to a subdirectory, in case we're deploying on a
# system with multiple versions of DB installed.
mkdir -p $RPM_BUILD_ROOT%_includedir/db4
mv $RPM_BUILD_ROOT%_includedir/*.h $RPM_BUILD_ROOT%_includedir/db4/

# Create symlinks so that "use <db.h> and link with -ldb" works.
for i in db.h db_cxx.h db_185.h; do
	ln -s db4/$i $RPM_BUILD_ROOT%_includedir
done

# Make sure that -ldb is functional.
ln -sf libdb-%major.so $RPM_BUILD_ROOT/%_lib/libdb.so

# *****ing versioning scheme...
ln -s libdb-4.4.so $RPM_BUILD_ROOT/%_lib/libdb-4.3.so
ln -s libdb_cxx-4.4.so $RPM_BUILD_ROOT%_libdir/libdb_cxx-4.3.so
ln -s libdb_tcl-4.4.so $RPM_BUILD_ROOT%_libdir/libdb_tcl-4.3.so

# stripping package
find $RPM_BUILD_ROOT -type f -exec /usr/bin/strip --strip-debug '{}' ';' 

%files
%defattr(-,root,root)
/%_lib/libdb-*.so
%_libdir/libdb_cxx-*.so
%_libdir/libdb_tcl-*.so
%_bindir/berkeley_db_svc
%_bindir/db_archive
%_bindir/db_checkpoint
%_bindir/db_deadlock
%_bindir/db_dump*
%_bindir/db_load
%_bindir/db_printlog
%_bindir/db_recover
%_bindir/db_stat
%_bindir/db_upgrade
%_bindir/db_verify
%_bindir/db_hotbackup

%files devel
%defattr(-,root,root)
%_includedir
/%_lib/libdb.so
%_libdir/libdb-%major.so
%_libdir/libdb_cxx.so
%_libdir/libdb_tcl.so
%_libdir/*.a
%_libdir/*.la

%files doc
%defattr(-,root,root)
%_datadir

%clean
rm -rf ${RPM_BUILD_ROOT}

%changelog
* Wed Mar 15 2006 Christian Wasem <wasem@ccux-linux.de> 4.4.20-1
- Update to Version 4.4.20
* Wed Nov 16 2005 Christian Wasem <wasem@ccux-linux.de> 4.3.29-1
- Update to Version 4.3.29 removed wrong Obsoletes-Tag
* Mon Jun 27 2005 Christian Wasem <wasem@ccux-linux.de> 4.3.28-2
- added db-4.3.28-lock.patch
* Sun Jun 26 2005 Christian Wasem <wasem@ccux-linux.de> 4.3.28-1
- update to Version 4.3.28